/* Software License Agreement
 *
 *     Copyright(C) 1994-2020 David Lindauer, (LADSoft)
 *
 *     This file is part of the Orange C Compiler package.
 *
 *     The Orange C Compiler package is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     The Orange C Compiler package is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with Orange C.  If not, see <http://www.gnu.org/licenses/>.
 *
 *     contact information:
 *         email: TouchStone222@runbox.com <David Lindauer>
 *
 */

#ifndef OBJUTIL_H
#define OBJUTIL_H

#include <string>
#include "ObjTypes.h"
class ObjUtil
{
  public:
    static ObjString ToHex(ObjInt value, int width = 0);
    static ObjString ToDecimal(ObjInt value, int width = 0);
    static ObjInt FromHex(const char* data, int* pos = nullptr, int width = 0) { return FromInt(data, pos, width, 16); }
    static ObjInt FromDecimal(const char* data, int* pos = nullptr, int width = 0) { return FromInt(data, pos, width, 10); }
    static ObjInt FromBinary(const char* data, int* pos = nullptr, int width = 0) { return FromInt(data, pos, width, 2); }
    static ObjInt FromOctal(const char* data, int* pos = nullptr, int width = 0) { return FromInt(data, pos, width, 8); }

  private:
    static ObjInt FromInt(const char* data, int* pos, int width, int radix);
};
#endif