/*
   cddef.h

   Base definitions

   Copyright (C) 1996 Free Software Foundation, Inc.

   This file is part of the Windows32 API Library.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   If you are interested in a warranty or support for this source code,
   contact Scott Christley <scottc@net-community.com> for more information.

   You should have received a copy of the GNU Library General Public
   License along with this library; see the file COPYING.LIB.
   If not, write to the Free Software Foundation,
   59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

   -----------
   DAL 2003 - this file modified extensively for my compiler.  New
   definitionswnwn added as well.
*/
#define COLOROKSTRINGA "commdlg_ColorOK"
#define COLOROKSTRINGW L"commdlg_ColorOK"

#define FILEOKSTRINGA "commdlg_FileNameOK"
#define FILEOKSTRINGW L"commdlg_FileNameOK"

#define FINDMSGSTRINGA "commdlg_FindReplace"
#define FINDMSGSTRINGW L"commdlg_FindReplace"

#define HELPMSGSTRINGA "commdlg_help"
#define HELPMSGSTRINGW L"commdlg_help"

#define LBSELCHSTRINGA "commdlg_LBSelChangedNotify"
#define LBSELCHSTRINGW L"commdlg_LBSelChangedNotify"

#define SETRGBSTRINGA "commdlg_SetRGBColor"
#define SETRGBSTRINGW L"commdlg_SetRGBColor"

#define SHAREVISTRINGA "commdlg_ShareViolation"
#define SHAREVISTRINGW L"commdlg_ShareViolation"

#define BOLD_FONTTYPE (256)

#define CC_ANYCOLOR (256)
#define CC_ENABLEHOOK (16)
#define CC_ENABLETEMPLATE (32)
#define CC_ENABLETEMPLATEHANDLE (64)
#define CC_FULLOPEN (2)
#define CC_PREVENTFULLOPEN (4)
#define CC_RGBINIT (1)
#define CC_SHOWHELP (8)
#define CC_SOLIDCOLOR (128)

#define CD_LBSELADD (2)
#define CD_LBSELCHANGE (0)
#define CD_LBSELNOITEMS (-1)
#define CD_LBSELSUB (1)

#define CF_ANSIONLY (1024)
#define CF_APPLY (512)
#define CF_BOTH (CF_SCREENFONTS | CF_PRINTERFONTS)
#define CF_EFFECTS (256)
#define CF_ENABLEHOOK (8)
#define CF_ENABLETEMPLATE (16)
#define CF_ENABLETEMPLATEHANDLE (32)
#define CF_FIXEDPITCHONLY (16384)
#define CF_FORCEFONTEXIST (65536)
#define CF_INITTOLOGFONTSTRUCT (64)
#define CF_LIMITSIZE (8192)
#define CF_NOFACESEL (524288)
#define CF_NOOEMFONTS CF_NOVECTORFONTS
#define CF_NOSCRIPTSEL (8388608)
#define CF_NOSIMULATIONS (4096)
#define CF_NOSIZESEL (2097152)
#define CF_NOSTYLESEL (1048576)
#define CF_NOVECTORFONTS (2048)
#define CF_NOVERTFONTS (16777216)
#define CF_PRINTERFONTS (2)
#define CF_SCALABLEONLY (131072)
#define CF_SCREENFONTS (1)
#define CF_SCRIPTSONLY CF_ANSIONLY
#define CF_SELECTSCRIPT (4194304)
#define CF_SHOWHELP (4)
#define CF_TTONLY (262144)
#define CF_USESTYLE (128)
#define CF_WYSIWYG (32768)

#define DN_DEFAULTPRN (1)

#define FR_DIALOGTERM (64)
#define FR_DOWN (1)
#define FR_ENABLEHOOK (256)
#define FR_ENABLETEMPLATE (512)
#define FR_ENABLETEMPLATEHANDLE (8192)
#define FR_FINDNEXT (8)
#define FR_HIDEMATCHCASE (32768)
#define FR_HIDEUPDOWN (16384)
#define FR_HIDEWHOLEWORD (65536)
#define FR_MATCHALEFHAMZA (2147483647)
#define FR_MATCHCASE (4)
#define FR_MATCHDIAC (536870912)
#define FR_MATCHKASHIDA (1073741824)
#define FR_NOMATCHCASE (2048)
#define FR_NOUPDOWN (1024)
#define FR_NOWHOLEWORD (4096)
#define FR_RAW (131072)
#define FR_REPLACE (16)
#define FR_REPLACEALL (32)
#define FR_SHOWHELP (128)
#define FR_WHOLEWORD (2)

// #define INTERFACE IPrintDialogCallback

#define ITALIC_FONTTYPE (512)

#define OFN_ALLOWMULTISELECT (512)
#define OFN_CREATEPROMPT (8192)
#define OFN_DONTADDTORECENT (33554432)
#define OFN_ENABLEHOOK (32)
#define OFN_ENABLEINCLUDENOTIFY (4194304)
#define OFN_ENABLESIZING (8388608)
#define OFN_ENABLETEMPLATE (64)
#define OFN_ENABLETEMPLATEHANDLE (128)
#define OFN_EXPLORER (524288)
#define OFN_EXTENSIONDIFFERENT (1024)
#define OFN_EX_NOPLACESBAR (1)
#define OFN_FILEMUSTEXIST (4096)
#define OFN_FORCESHOWHIDDEN (268435456)
#define OFN_HIDEREADONLY (4)
#define OFN_LONGNAMES (2097152)
#define OFN_NOCHANGEDIR (8)
#define OFN_NODEREFERENCELINKS (1048576)
#define OFN_NOLONGNAMES (262144)
#define OFN_NONETWORKBUTTON (131072)
#define OFN_NOREADONLYRETURN (32768)
#define OFN_NOTESTFILECREATE (65536)
#define OFN_NOVALIDATE (256)
#define OFN_OVERWRITEPROMPT (2)
#define OFN_PATHMUSTEXIST (2048)
#define OFN_READONLY (1)
#define OFN_SHAREAWARE (16384)
#define OFN_SHAREFALLTHROUGH (2)
#define OFN_SHARENOWARN (1)
#define OFN_SHAREWARN (0)
#define OFN_SHOWHELP (16)

#define PD_ALLPAGES (0)
#define PD_COLLATE (16)
#define PD_CURRENTPAGE (4194304)
#define PD_DISABLEPRINTTOFILE (524288)
#define PD_ENABLEPRINTHOOK (4096)
#define PD_ENABLEPRINTTEMPLATE (16384)
#define PD_ENABLEPRINTTEMPLATEHANDLE (65536)
#define PD_ENABLESETUPHOOK (8192)
#define PD_ENABLESETUPTEMPLATE (32768)
#define PD_ENABLESETUPTEMPLATEHANDLE (131072)
#define PD_EXCLUSIONFLAGS (16777216)
#define PD_EXCL_COPIESANDCOLLATE (DM_COPIES | DM_COLLATE)
#define PD_HIDEPRINTTOFILE (1048576)
#define PD_NOCURRENTPAGE (8388608)
#define PD_NONETWORKBUTTON (2097152)
#define PD_NOPAGENUMS (8)
#define PD_NOSELECTION (4)
#define PD_NOWARNING (128)
#define PD_PAGENUMS (2)
#define PD_PRINTSETUP (64)
#define PD_PRINTTOFILE (32)
#define PD_RESULT_APPLY (2)
#define PD_RESULT_CANCEL (0)
#define PD_RESULT_PRINT (1)
#define PD_RETURNDC (256)
#define PD_RETURNDEFAULT (1024)
#define PD_RETURNIC (512)
#define PD_SELECTION (1)
#define PD_SHOWHELP (2048)
#define PD_USEDEVMODECOPIES (262144)
#define PD_USEDEVMODECOPIESANDCOLLATE (262144)
#define PD_USELARGETEMPLATE (268435456)

#define PRINTER_FONTTYPE (16384)

#define PSD_DEFAULTMINMARGINS (0)
#define PSD_DISABLEMARGINS (16)
#define PSD_DISABLEORIENTATION (256)
#define PSD_DISABLEPAGEPAINTING (524288)
#define PSD_DISABLEPAPER (512)
#define PSD_DISABLEPRINTER (32)
#define PSD_ENABLEPAGEPAINTHOOK (262144)
#define PSD_ENABLEPAGESETUPHOOK (8192)
#define PSD_ENABLEPAGESETUPTEMPLATE (32768)
#define PSD_ENABLEPAGESETUPTEMPLATEHANDLE (131072)
#define PSD_INHUNDREDTHSOFMILLIMETERS (8)
#define PSD_INTHOUSANDTHSOFINCHES (4)
#define PSD_INWININIINTLMEASURE (0)
#define PSD_MARGINS (2)
#define PSD_MINMARGINS (1)
#define PSD_NONETWORKBUTTON (2097152)
#define PSD_NOWARNING (128)
#define PSD_RETURNDEFAULT (1024)
#define PSD_SHOWHELP (2048)

#define PS_OPENTYPE_FONTTYPE (65536)

#define REGULAR_FONTTYPE (1024)

#define SCREEN_FONTTYPE (8192)

#define SIMULATED_FONTTYPE (32768)

#define START_PAGE_GENERAL (2147483647)

#define TT_OPENTYPE_FONTTYPE (131072)

#define TYPE1_FONTTYPE (262144)

#define WM_CHOOSEFONT_GETLOGFONT (1025)
#define WM_CHOOSEFONT_SETFLAGS (1126)
#define WM_CHOOSEFONT_SETLOGFONT (1125)
#define WM_PSD_ENVSTAMPRECT (1029)
#define WM_PSD_FULLPAGERECT (1025)
#define WM_PSD_GREEKTEXTRECT (1028)
#define WM_PSD_MARGINRECT (1027)
#define WM_PSD_MINMARGINRECT (1026)
#define WM_PSD_PAGESETUPDLG (1024)
#define WM_PSD_YAFULLPAGERECT (1030)

#define CDERR_DIALOGFAILURE   (65535)

#define CDERR_GENERALCODES     (0)
#define CDERR_STRUCTSIZE       (1)
#define CDERR_INITIALIZATION   (2)
#define CDERR_NOTEMPLATE       (3)
#define CDERR_NOHINSTANCE      (4)
#define CDERR_LOADSTRFAILURE   (5)
#define CDERR_FINDRESFAILURE   (6)
#define CDERR_LOADRESFAILURE   (7)
#define CDERR_LOCKRESFAILURE   (8)
#define CDERR_MEMALLOCFAILURE  (9)
#define CDERR_MEMLOCKFAILURE   (10)
#define CDERR_NOHOOK           (11)
#define CDERR_REGISTERMSGFAIL  (12)

#define PDERR_PRINTERCODES     (4096)
#define PDERR_SETUPFAILURE     (4097)
#define PDERR_PARSEFAILURE     (4098)
#define PDERR_RETDEFFAILURE    (4099)
#define PDERR_LOADDRVFAILURE   (4100)
#define PDERR_GETDEVMODEFAIL   (4101)
#define PDERR_INITFAILURE      (4102)
#define PDERR_NODEVICES        (4103)
#define PDERR_NODEFAULTPRN     (4104)
#define PDERR_DNDMMISMATCH     (4105)
#define PDERR_CREATEICFAILURE  (4106)
#define PDERR_PRINTERNOTFOUND  (4107)
#define PDERR_DEFAULTDIFFERENT (4108)

#define CFERR_CHOOSEFONTCODES  (8192)
#define CFERR_NOFONTS          (8193)
#define CFERR_MAXLESSTHANMIN   (8194)

#define FNERR_FILENAMECODES    (12288)
#define FNERR_SUBCLASSFAILURE  (12289)
#define FNERR_INVALIDFILENAME  (12290)
#define FNERR_BUFFERTOOSMALL   (12291)

#define FRERR_FINDREPLACECODES (16384)
#define FRERR_BUFFERLENGTHZERO (16385)

#define CCERR_CHOOSECOLORCODES (20480)

#define _INC_COMMDLG

#ifdef UNICODE
#define COLOROKSTRING COLOROKSTRINGW
#define FILEOKSTRING FILEOKSTRINGW
#define FINDMSGSTRING FINDMSGSTRINGW
#define HELPMSGSTRING HELPMSGSTRINGW
#define LBSELCHSTRING LBSELCHSTRINGW
#define SETRGBSTRING SETRGBSTRINGW
#define SHAREVISTRING SHAREVISTRINGW
#else
#define COLOROKSTRING COLOROKSTRINGA
#define FILEOKSTRING FILEOKSTRINGA
#define FINDMSGSTRING FINDMSGSTRINGA
#define HELPMSGSTRING HELPMSGSTRINGA
#define LBSELCHSTRING LBSELCHSTRINGA
#define SETRGBSTRING SETRGBSTRINGA
#define SHAREVISTRING SHAREVISTRINGA
#endif
